Loading...
Searching...
No Matches
juce::String Class Referencefinal

## Detailed Description

The JUCE String class!

Using a reference-counted internal representation, these strings are fast and efficient, and there are methods to do just about any operation you'll ever dream of.

See also
  StringArray, StringPairArray

The documentation for this class was generated from the following file:

- juce_core/text/juce_String.h

## Public Types

using | CharPointerType = CharPointer_UTF8
| This is the character encoding type used internally to store the string.

## Public Member Functions

| String () noexcept
| Creates an empty string.
| String (const String &) noexcept
| Creates a copy of another string.
| String (String &&) noexcept
| Move constructor.
| String (const char *text)
| Creates a string from a zero-terminated ascii text string.
| String (const char *text, size_t maxChars)
| Creates a string from a string of 8-bit ascii characters.
| String (const wchar_t *text)
| Creates a string from a wchar_t character string.
| String (const wchar_t *text, size_t maxChars)
| Creates a string from a wchar_t character string.
| String (const char8_t *text)
| Creates a string from a char8_t character string.
| String (const char8_t *text, size_t maxChars)
| Creates a string from a char8_t character string.
| String (CharPointer_UTF8 text)
| Creates a string from a UTF-8 character string.
| String (CharPointer_UTF8 text, size_t maxChars)
| Creates a string from a UTF-8 character string.
| String (CharPointer_UTF8 start, CharPointer_UTF8 end)
| Creates a string from a UTF-8 character string.
| String (CharPointer_UTF16 text)
| Creates a string from a UTF-16 character string.
| String (CharPointer_UTF16 text, size_t maxChars)
| Creates a string from a UTF-16 character string.
| String (CharPointer_UTF16 start, CharPointer_UTF16 end)
| Creates a string from a UTF-16 character string.
| String (CharPointer_UTF32 text)
| Creates a string from a UTF-32 character string.
| String (CharPointer_UTF32 text, size_t maxChars)
| Creates a string from a UTF-32 character string.
| String (CharPointer_UTF32 start, CharPointer_UTF32 end)
| Creates a string from a UTF-32 character string.
| String (CharPointer_ASCII text)
| Creates a string from an ASCII character string.
| String (const std::string &)
| Creates a string from a UTF-8 encoded std::string.
| String (StringRef)
| Creates a string from a StringRef.
| ~String () noexcept
| Destructor.
int | hashCode () const noexcept
| Generates a probably-unique 32-bit hashcode from this string.
int64 | hashCode64 () const noexcept
| Generates a probably-unique 64-bit hashcode from this string.
size_t | hash () const noexcept
| Generates a probably-unique hashcode from this string.
int | length () const noexcept
| Returns the number of characters in the string.
String & | operator= (const String &other) noexcept
| Replaces this string's contents with another string.
String & | operator= (String &&other) noexcept
| Moves the contents of another string to the receiver.
String & | operator+= (const String &stringToAppend)
| Appends another string at the end of this one.
String & | operator+= (const char *textToAppend)
| Appends another string at the end of this one.
String & | operator+= (const wchar_t *textToAppend)
| Appends another string at the end of this one.
String & | operator+= (StringRef textToAppend)
| Appends another string at the end of this one.
String & | operator+= (int numberToAppend)
| Appends a decimal number at the end of this string.
String & | operator+= (long numberToAppend)
| Appends a decimal number at the end of this string.
String & | operator+= (int64 numberToAppend)
| Appends a decimal number at the end of this string.
String & | operator+= (uint64 numberToAppend)
| Appends a decimal number at the end of this string.
String & | operator+= (char characterToAppend)
| Appends a character at the end of this string.
String & | operator+= (wchar_t characterToAppend)
| Appends a character at the end of this string.
String & | operator+= (juce_wchar characterToAppend)
| Appends a character at the end of this string.
void | append (const String &textToAppend, size_t maxCharsToTake)
| Appends a string to the end of this one.
void | appendCharPointer (CharPointerType startOfTextToAppend, CharPointerType endOfTextToAppend)
| Appends a string to the end of this one.
template<class CharPointer>
void | appendCharPointer (CharPointer startOfTextToAppend, CharPointer endOfTextToAppend)
| Appends a string to the end of this one.
void | appendCharPointer (CharPointerType textToAppend)
| Appends a string to the end of this one.
template<class CharPointer>
void | appendCharPointer (CharPointer textToAppend, size_t maxCharsToTake)
| Appends a string to the end of this one.
template<class CharPointer>
void | appendCharPointer (CharPointer textToAppend)
| Appends a string to the end of this one.
bool | isEmpty () const noexcept
| Returns true if the string contains no characters.
bool | isNotEmpty () const noexcept
| Returns true if the string contains at least one character.
void | clear () noexcept
| Resets this string to be empty.
bool | equalsIgnoreCase (const String &other) const noexcept
| Case-insensitive comparison with another string.
bool | equalsIgnoreCase (StringRef other) const noexcept
| Case-insensitive comparison with another string.
bool | equalsIgnoreCase (const wchar_t *other) const noexcept
| Case-insensitive comparison with another string.
bool | equalsIgnoreCase (const char *other) const noexcept
| Case-insensitive comparison with another string.
int | compare (const String &other) const noexcept
| Case-sensitive comparison with another string.
int | compare (const char *other) const noexcept
| Case-sensitive comparison with another string.
int | compare (const wchar_t *other) const noexcept
| Case-sensitive comparison with another string.
int | compareIgnoreCase (const String &other) const noexcept
| Case-insensitive comparison with another string.
int | compareNatural (StringRef other, bool isCaseSensitive=false) const noexcept
| Compares two strings, taking into account textual characteristics like numbers and spaces.
bool | startsWith (StringRef text) const noexcept
| Tests whether the string begins with another string.
bool | startsWithChar (juce_wchar character) const noexcept
| Tests whether the string begins with a particular character.
bool | startsWithIgnoreCase (StringRef text) const noexcept
| Tests whether the string begins with another string.
bool | endsWith (StringRef text) const noexcept
| Tests whether the string ends with another string.
bool | endsWithChar (juce_wchar character) const noexcept
| Tests whether the string ends with a particular character.
bool | endsWithIgnoreCase (StringRef text) const noexcept
| Tests whether the string ends with another string.
bool | contains (StringRef text) const noexcept
| Tests whether the string contains another substring.
bool | containsChar (juce_wchar character) const noexcept
| Tests whether the string contains a particular character.
bool | containsIgnoreCase (StringRef text) const noexcept
| Tests whether the string contains another substring.
bool | containsWholeWord (StringRef wordToLookFor) const noexcept
| Tests whether the string contains another substring as a distinct word.
bool | containsWholeWordIgnoreCase (StringRef wordToLookFor) const noexcept
| Tests whether the string contains another substring as a distinct word.
int | indexOfWholeWord (StringRef wordToLookFor) const noexcept
| Finds an instance of another substring if it exists as a distinct word.
int | indexOfWholeWordIgnoreCase (StringRef wordToLookFor) const noexcept
| Finds an instance of another substring if it exists as a distinct word.
bool | containsAnyOf (StringRef charactersItMightContain) const noexcept
| Looks for any of a set of characters in the string.
bool | containsOnly (StringRef charactersItMightContain) const noexcept
| Looks for a set of characters in the string.
bool | containsNonWhitespaceChars () const noexcept
| Returns true if this string contains any non-whitespace characters.
bool | matchesWildcard (StringRef wildcard, bool ignoreCase) const noexcept
| Returns true if the string matches this simple wildcard expression.
int | indexOfChar (juce_wchar characterToLookFor) const noexcept
| Searches for a character inside this string.
int | indexOfChar (int startIndex, juce_wchar characterToLookFor) const noexcept
| Searches for a character inside this string.
int | indexOfAnyOf (StringRef charactersToLookFor, int startIndex=0, bool ignoreCase=false) const noexcept
| Returns the index of the first character that matches one of the characters passed-in to this method.
int | indexOf (StringRef textToLookFor) const noexcept
| Searches for a substring within this string.
int | indexOf (int startIndex, StringRef textToLookFor) const noexcept
| Searches for a substring within this string.
int | indexOfIgnoreCase (StringRef textToLookFor) const noexcept
| Searches for a substring within this string.
int | indexOfIgnoreCase (int startIndex, StringRef textToLookFor) const noexcept
| Searches for a substring within this string.
int | lastIndexOfChar (juce_wchar character) const noexcept
| Searches for a character inside this string (working backwards from the end of the string).
int | lastIndexOf (StringRef textToLookFor) const noexcept
| Searches for a substring inside this string (working backwards from the end of the string).
int | lastIndexOfIgnoreCase (StringRef textToLookFor) const noexcept
| Searches for a substring inside this string (working backwards from the end of the string).
int | lastIndexOfAnyOf (StringRef charactersToLookFor, bool ignoreCase=false) const noexcept
| Returns the index of the last character in this string that matches one of the characters passed-in to this method.
juce_wchar | operator[] (int index) const noexcept
| Returns the character at this index in the string.
juce_wchar | getLastCharacter () const noexcept
| Returns the final character of the string.
String | substring (int startIndex, int endIndex) const
| Returns a subsection of the string.
String | substring (int startIndex) const
| Returns a section of the string, starting from a given position.
String | dropLastCharacters (int numberToDrop) const
| Returns a version of this string with a number of characters removed from the end.
String | getLastCharacters (int numCharacters) const
| Returns a number of characters from the end of the string.
String | fromFirstOccurrenceOf (StringRef substringToStartFrom, bool includeSubStringInResult, bool ignoreCase) const
| Returns a section of the string starting from a given substring.
String | fromLastOccurrenceOf (StringRef substringToFind, bool includeSubStringInResult, bool ignoreCase) const
| Returns a section of the string starting from the last occurrence of a given substring.
String | upToFirstOccurrenceOf (StringRef substringToEndWith, bool includeSubStringInResult, bool ignoreCase) const
| Returns the start of this string, up to the first occurrence of a substring.
String | upToLastOccurrenceOf (StringRef substringToFind, bool includeSubStringInResult, bool ignoreCase) const
| Returns the start of this string, up to the last occurrence of a substring.
String | trim () const
| Returns a copy of this string with any whitespace characters removed from the start and end.
String | trimStart () const
| Returns a copy of this string with any whitespace characters removed from the start.
String | trimEnd () const
| Returns a copy of this string with any whitespace characters removed from the end.
String | trimCharactersAtStart (StringRef charactersToTrim) const
| Returns a copy of this string, having removed a specified set of characters from its start.
String | trimCharactersAtEnd (StringRef charactersToTrim) const
| Returns a copy of this string, having removed a specified set of characters from its end.
String | toUpperCase () const
| Returns an upper-case version of this string.
String | toLowerCase () const
| Returns an lower-case version of this string.
String | replaceSection (int startIndex, int numCharactersToReplace, StringRef stringToInsert) const
| Replaces a sub-section of the string with another string.
String | replace (StringRef stringToReplace, StringRef stringToInsertInstead, bool ignoreCase=false) const
| Replaces all occurrences of a substring with another string.
String | replaceFirstOccurrenceOf (StringRef stringToReplace, StringRef stringToInsertInstead, bool ignoreCase=false) const
| Replaces the first occurrence of a substring with another string.
String | replaceCharacter (juce_wchar characterToReplace, juce_wchar characterToInsertInstead) const
| Returns a string with all occurrences of a character replaced with a different one.
String | replaceCharacters (StringRef charactersToReplace, StringRef charactersToInsertInstead) const
| Replaces a set of characters with another set.
String | retainCharacters (StringRef charactersToRetain) const
| Returns a version of this string that only retains a fixed set of characters.
String | removeCharacters (StringRef charactersToRemove) const
| Returns a version of this string with a set of characters removed.
String | initialSectionContainingOnly (StringRef permittedCharacters) const
| Returns a section from the start of the string that only contains a certain set of characters.
String | initialSectionNotContaining (StringRef charactersToStopAt) const
| Returns a section from the start of the string that only contains a certain set of characters.
bool | isQuotedString () const
| Checks whether the string might be in quotation marks.
String | unquoted () const
| Removes quotation marks from around the string, (if there are any).
String | quoted (juce_wchar quoteCharacter='"') const
| Adds quotation marks around a string.
String | paddedLeft (juce_wchar padCharacter, int minimumLength) const
| Returns a copy of this string with the specified character repeatedly added to its beginning until the total length is at least the minimum length specified.
String | paddedRight (juce_wchar padCharacter, int minimumLength) const
| Returns a copy of this string with the specified character repeatedly added to its end until the total length is at least the minimum length specified.
CharPointerType | begin () const
| Returns an iterator pointing at the beginning of the string.
CharPointerType | end () const
| Returns an iterator pointing at the terminating null of the string.
| String (int decimalInteger)
| Creates a string containing this signed 32-bit integer as a decimal number.
| String (unsigned int decimalInteger)
| Creates a string containing this unsigned 32-bit integer as a decimal number.
| String (short decimalInteger)
| Creates a string containing this signed 16-bit integer as a decimal number.
| String (unsigned short decimalInteger)
| Creates a string containing this unsigned 16-bit integer as a decimal number.
| String (int64 largeIntegerValue)
| Creates a string containing this signed 64-bit integer as a decimal number.
| String (uint64 largeIntegerValue)
| Creates a string containing this unsigned 64-bit integer as a decimal number.
| String (long decimalInteger)
| Creates a string containing this signed long integer as a decimal number.
| String (unsigned long decimalInteger)
| Creates a string containing this unsigned long integer as a decimal number.
| String (float floatValue)
| Creates a string representing this floating-point number.
| String (double doubleValue)
| Creates a string representing this floating-point number.
| String (float floatValue, int numberOfDecimalPlaces, bool useScientificNotation=false)
| Creates a string representing this floating-point number.
| String (double doubleValue, int numberOfDecimalPlaces, bool useScientificNotation=false)
| Creates a string representing this floating-point number.
int | getIntValue () const noexcept
| Reads the value of the string as a decimal number (up to 32 bits in size).
int64 | getLargeIntValue () const noexcept
| Reads the value of the string as a decimal number (up to 64 bits in size).
int | getTrailingIntValue () const noexcept
| Parses a decimal number from the end of the string.
float | getFloatValue () const noexcept
| Parses this string as a floating point number.
double | getDoubleValue () const noexcept
| Parses this string as a floating point number.
int | getHexValue32 () const noexcept
| Parses the string as a hexadecimal number.
int64 | getHexValue64 () const noexcept
| Parses the string as a hexadecimal number.
CharPointerType | getCharPointer () const noexcept
| Returns the character pointer currently being used to store this string.
CharPointer_UTF8 | toUTF8 () const
| Returns a pointer to a UTF-8 version of this string.
const char * | toRawUTF8 () const
| Returns a pointer to a UTF-8 version of this string.
CharPointer_UTF16 | toUTF16 () const
| Returns a pointer to a UTF-16 version of this string.
CharPointer_UTF32 | toUTF32 () const
| Returns a pointer to a UTF-32 version of this string.
const wchar_t * | toWideCharPointer () const
| Returns a pointer to a wchar_t version of this string.
std::string | toStdString () const
size_t | getNumBytesAsUTF8 () const noexcept
| Returns the number of bytes required to represent this string as UTF8.
size_t | copyToUTF8 (CharPointer_UTF8::CharType *destBuffer, size_t maxBufferSizeBytes) const noexcept
| Copies the string to a buffer as UTF-8 characters.
size_t | copyToUTF16 (CharPointer_UTF16::CharType *destBuffer, size_t maxBufferSizeBytes) const noexcept
| Copies the string to a buffer as UTF-16 characters.
size_t | copyToUTF32 (CharPointer_UTF32::CharType *destBuffer, size_t maxBufferSizeBytes) const noexcept
| Copies the string to a buffer as UTF-32 characters.
void | preallocateBytes (size_t numBytesNeeded)
| Increases the string's internally allocated storage.
void | swapWith (String &other) noexcept
| Swaps the contents of this string with another one.
CFStringRef | toCFString () const
| OSX ONLY - Converts this string to a CFString.
String | convertToPrecomposedUnicode () const
| OSX ONLY - Returns a copy of this string in which any decomposed unicode characters have been converted to their precomposed equivalents.
int | getReferenceCount () const noexcept
| Returns the number of String objects which are currently sharing the same internal data as this one.

## Static Public Member Functions

static String | charToString (juce_wchar character)
| Creates a string from a single character.
static String | repeatedString (StringRef stringToRepeat, int numberOfTimesToRepeat)
| Creates a string which is a version of a string repeated and joined together.
static String | createStringFromData (const void *data, int size)
| Creates a string from data in an unknown format.
template<typename... Args>
static String | formatted (const String &formatStr, Args... args)
| Creates a String from a printf-style parameter list.
template<typename IntegerType>
static String | toHexString (IntegerType number)
| Returns a string representing this numeric value in hexadecimal.
static String | toHexString (const void *data, int size, int groupSize=1)
| Returns a string containing a hex dump of a block of binary data.
template<typename DecimalType>
static String | toDecimalStringWithSignificantFigures (DecimalType number, int numberOfSignificantFigures)
| Returns a string containing a decimal with a set number of significant figures.
static String | fromUTF8 (const char *utf8buffer, int bufferSizeBytes=-1)
| Creates a String from a UTF-8 encoded buffer.
static String | fromUTF8 (const char8_t *utf8buffer, int bufferSizeBytes=-1)
| Creates a String from a UTF-8 encoded buffer.
static String | fromCFString (CFStringRef cfString)
| OSX ONLY - Creates a String from an OSX CFString.

## Member Typedef Documentation

## CharPointerType

using juce::String::CharPointerType = CharPointer_UTF8

This is the character encoding type used internally to store the string.

By setting the value of JUCE_STRING_UTF_TYPE to 8, 16, or 32, you can change the internal storage format of the String class. UTF-8 uses the least space (if your strings contain few extended characters), but call operator[] involves iterating the string to find the required index. UTF-32 provides instant random access to its characters, but uses 4 bytes per character to store them. UTF-16 uses more space than UTF-8 and is also slow to index, but is the native wchar_t format used in Windows.

It doesn't matter too much which format you pick, because the toUTF8(), toUTF16() and toUTF32() methods let you access the string's content in any of the other formats.

## Constructors and Destructors

## String() [1/33]

juce::String::String | ( |  | ) |

noexcept

Creates an empty string.

See also
  empty

Referenced by append(), charToString(), compare(), compareIgnoreCase(), convertToPrecomposedUnicode(), createStringFromData(), dropLastCharacters(), equalsIgnoreCase(), formatted(), fromCFString(), fromFirstOccurrenceOf(), fromLastOccurrenceOf(), fromUTF8(), fromUTF8(), getLastCharacters(), getReferenceCount(), initialSectionContainingOnly(), initialSectionNotContaining(), operator+=(), operator+=(), operator+=(), operator+=(), operator+=(), operator+=(), operator+=(), operator+=(), operator+=(), operator+=(), operator+=(), operator=(), operator=(), paddedLeft(), paddedRight(), quoted(), removeCharacters(), repeatedString(), replace(), replaceCharacter(), replaceCharacters(), replaceFirstOccurrenceOf(), replaceSection(), retainCharacters(), String(), String(), String(), String(), String(), String(), String(), substring(), substring(), swapWith(), toDecimalStringWithSignificantFigures(), toHexString(), toHexString(), toLowerCase(), toUpperCase(), trim(), trimCharactersAtEnd(), trimCharactersAtStart(), trimEnd(), trimStart(), unquoted(), upToFirstOccurrenceOf(), and upToLastOccurrenceOf().

## String() [2/33]

juce::String::String | ( | const String & |  | ) |

noexcept

Creates a copy of another string.

References String().

## String() [3/33]

juce::String::String | ( | String && |  | ) |

noexcept

Move constructor.

References String().

## String() [4/33]

juce::String::String | ( | const char * | text | ) |

Creates a string from a zero-terminated ascii text string.

The string passed-in must not contain any characters with a value above 127, because these can't be converted to unicode without knowing the original encoding that was used to create the string. If you attempt to pass-in values above 127, you'll get an assertion.

To create strings with extended characters from UTF-8, you should explicitly call String (CharPointer_UTF8 ("my utf8 string.")). It's highly recommended that you use UTF-8 with escape characters in your source code to represent extended characters, because there's no other way to represent unicode strings in a way that isn't dependent on the compiler, source code editor and platform.

References String().

## String() [5/33]

juce::String::String | ( | const char * | text,
|  | size_t | maxChars )

Creates a string from a string of 8-bit ascii characters.

The string passed-in must not contain any characters with a value above 127, because these can't be converted to unicode without knowing the original encoding that was used to create the string. If you attempt to pass-in values above 127, you'll get an assertion.

To create strings with extended characters from UTF-8, you should explicitly call String (CharPointer_UTF8 ("my utf8 string.")). In C++20 or later, you may alternatively pass a char8_t string to indicate a UTF-8 encoding. It's highly recommended that you use UTF-8 with escape characters in your source code to represent extended characters, because there's no other way to represent unicode strings in a way that isn't dependent on the compiler, source code editor and platform.

This will read up to the first maxChars bytes of the string, or until a null terminator is reached, whichever happens first.

References String().

## String() [6/33]

juce::String::String | ( | const wchar_t * | text | ) |

Creates a string from a wchar_t character string.

Depending on the platform, this may be treated as either UTF-32 or UTF-16.

References String().

## String() [7/33]

juce::String::String | ( | const wchar_t * | text,
|  | size_t | maxChars )

Creates a string from a wchar_t character string.

Depending on the platform, this may be treated as either UTF-32 or UTF-16.

References String().

## String() [8/33]

juce::String::String | ( | const char8_t * | text | ) |

Creates a string from a char8_t character string.

## String() [9/33]

juce::String::String | ( | const char8_t * | text,
|  | size_t | maxChars )

Creates a string from a char8_t character string.

This will read up to the first maxChars bytes of the string, or until a null terminator is reached, whichever happens first.

## String() [10/33]

juce::String::String | ( | CharPointer_UTF8 | text | ) |

Creates a string from a UTF-8 character string.

## String() [11/33]

juce::String::String | ( | CharPointer_UTF8 | text,
|  | size_t | maxChars )

Creates a string from a UTF-8 character string.

## String() [12/33]

juce::String::String | ( | CharPointer_UTF8 | start,
|  | CharPointer_UTF8 | end )

Creates a string from a UTF-8 character string.

References end().

## String() [13/33]

juce::String::String | ( | CharPointer_UTF16 | text | ) |

Creates a string from a UTF-16 character string.

## String() [14/33]

juce::String::String | ( | CharPointer_UTF16 | text,
|  | size_t | maxChars )

Creates a string from a UTF-16 character string.

## String() [15/33]

juce::String::String | ( | CharPointer_UTF16 | start,
|  | CharPointer_UTF16 | end )

Creates a string from a UTF-16 character string.

References end().

## String() [16/33]

juce::String::String | ( | CharPointer_UTF32 | text | ) |

Creates a string from a UTF-32 character string.

## String() [17/33]

juce::String::String | ( | CharPointer_UTF32 | text,
|  | size_t | maxChars )

Creates a string from a UTF-32 character string.

## String() [18/33]

juce::String::String | ( | CharPointer_UTF32 | start,
|  | CharPointer_UTF32 | end )

Creates a string from a UTF-32 character string.

References end().

## String() [19/33]

juce::String::String | ( | CharPointer_ASCII | text | ) |

Creates a string from an ASCII character string.

## String() [20/33]

juce::String::String | ( | const std::string & |  | ) |

Creates a string from a UTF-8 encoded std::string.

## String() [21/33]

juce::String::String | ( | StringRef |  | ) |

Creates a string from a StringRef.

## ~String()

juce::String::~String | ( |  | ) |

noexcept

Destructor.

## String() [22/33]

juce::String::String | ( | int | decimalInteger | ) |

explicit

Creates a string containing this signed 32-bit integer as a decimal number.

See also
  getIntValue, getFloatValue, getDoubleValue, toHexString

## String() [23/33]

juce::String::String | ( | unsigned int | decimalInteger | ) |

explicit

Creates a string containing this unsigned 32-bit integer as a decimal number.

See also
  getIntValue, getFloatValue, getDoubleValue, toHexString

## String() [24/33]

juce::String::String | ( | short | decimalInteger | ) |

explicit

Creates a string containing this signed 16-bit integer as a decimal number.

See also
  getIntValue, getFloatValue, getDoubleValue, toHexString

## String() [25/33]

juce::String::String | ( | unsigned short | decimalInteger | ) |

explicit

Creates a string containing this unsigned 16-bit integer as a decimal number.

See also
  getIntValue, getFloatValue, getDoubleValue, toHexString

## String() [26/33]

juce::String::String | ( | int64 | largeIntegerValue | ) |

explicit

Creates a string containing this signed 64-bit integer as a decimal number.

See also
  getLargeIntValue, getFloatValue, getDoubleValue, toHexString

## String() [27/33]

juce::String::String | ( | uint64 | largeIntegerValue | ) |

explicit

Creates a string containing this unsigned 64-bit integer as a decimal number.

See also
  getLargeIntValue, getFloatValue, getDoubleValue, toHexString

## String() [28/33]

juce::String::String | ( | long | decimalInteger | ) |

explicit

Creates a string containing this signed long integer as a decimal number.

See also
  getIntValue, getFloatValue, getDoubleValue, toHexString

## String() [29/33]

juce::String::String | ( | unsigned long | decimalInteger | ) |

explicit

Creates a string containing this unsigned long integer as a decimal number.

See also
  getIntValue, getFloatValue, getDoubleValue, toHexString

## String() [30/33]

juce::String::String | ( | float | floatValue | ) |

explicit

Creates a string representing this floating-point number.

Parameters

  floatValue | the value to convert to a string

See also
  getDoubleValue, getIntValue

## String() [31/33]

juce::String::String | ( | double | doubleValue | ) |

explicit

Creates a string representing this floating-point number.

Parameters

  doubleValue | the value to convert to a string

See also
  getFloatValue, getIntValue

## String() [32/33]

juce::String::String | ( | float | floatValue,
|  | int | numberOfDecimalPlaces,
|  | bool | useScientificNotation = false )

Creates a string representing this floating-point number.

Parameters

  floatValue | the value to convert to a string
  numberOfDecimalPlaces | if this is > 0 the number will be formatted using that many decimal places, adding trailing zeros as required. If 0 or less the number will be formatted using the C++ standard library default format, which uses scientific notation for large and small numbers.
  useScientificNotation | if the number should be formatted using scientific notation

See also
  getDoubleValue, getIntValue

## String() [33/33]

juce::String::String | ( | double | doubleValue,
|  | int | numberOfDecimalPlaces,
|  | bool | useScientificNotation = false )

Creates a string representing this floating-point number.

Parameters

  doubleValue | the value to convert to a string
  numberOfDecimalPlaces | if this is > 0, it will format the number using that many decimal places, adding trailing zeros as required, and will not use exponent notation. If 0 or less, it will use exponent notation if necessary.
  useScientificNotation | if the number should be formatted using scientific notation

See also
  getFloatValue, getIntValue

References String().

## Member Functions

## charToString()

String juce::String::charToString | ( | juce_wchar | character | ) |

static

Creates a string from a single character.

References String().

## hashCode()

int juce::String::hashCode | ( |  | ) | const

noexcept

Generates a probably-unique 32-bit hashcode from this string.

## hashCode64()

int64 juce::String::hashCode64 | ( |  | ) | const

noexcept

Generates a probably-unique 64-bit hashcode from this string.

References hashCode64().

Referenced by hashCode64().

## hash()

size_t juce::String::hash | ( |  | ) | const

noexcept

Generates a probably-unique hashcode from this string.

References hash().

Referenced by hash().

## length()

int juce::String::length | ( |  | ) | const

noexcept

Returns the number of characters in the string.

References length().

Referenced by length().

## operator=() [1/2]

String & juce::String::operator= | ( | const String & | other | ) |

noexcept

Replaces this string's contents with another string.

References String().

## operator=() [2/2]

String & juce::String::operator= | ( | String && | other | ) |

noexcept

Moves the contents of another string to the receiver.

References String().

## operator+=() [1/11]

String & juce::String::operator+= | ( | const String & | stringToAppend | ) |

Appends another string at the end of this one.

References String().

## operator+=() [2/11]

String & juce::String::operator+= | ( | const char * | textToAppend | ) |

Appends another string at the end of this one.

References String().

## operator+=() [3/11]

String & juce::String::operator+= | ( | const wchar_t * | textToAppend | ) |

Appends another string at the end of this one.

References String().

## operator+=() [4/11]

String & juce::String::operator+= | ( | StringRef | textToAppend | ) |

Appends another string at the end of this one.

References String().

## operator+=() [5/11]

String & juce::String::operator+= | ( | int | numberToAppend | ) |

Appends a decimal number at the end of this string.

References String().

## operator+=() [6/11]

String & juce::String::operator+= | ( | long | numberToAppend | ) |

Appends a decimal number at the end of this string.

References String().

## operator+=() [7/11]

String & juce::String::operator+= | ( | int64 | numberToAppend | ) |

Appends a decimal number at the end of this string.

References String().

## operator+=() [8/11]

String & juce::String::operator+= | ( | uint64 | numberToAppend | ) |

Appends a decimal number at the end of this string.

References String().

## operator+=() [9/11]

String & juce::String::operator+= | ( | char | characterToAppend | ) |

Appends a character at the end of this string.

References String().

## operator+=() [10/11]

String & juce::String::operator+= | ( | wchar_t | characterToAppend | ) |

Appends a character at the end of this string.

References String().

## operator+=() [11/11]

String & juce::String::operator+= | ( | juce_wchar | characterToAppend | ) |

Appends a character at the end of this string.

References String().

## append()

void juce::String::append | ( | const String & | textToAppend,
|  | size_t | maxCharsToTake )

Appends a string to the end of this one.

Parameters

  textToAppend | the string to add
  maxCharsToTake | the maximum number of characters to take from the string passed in

References String().

## appendCharPointer() [1/5]

void juce::String::appendCharPointer | ( | CharPointerType | startOfTextToAppend,
|  | CharPointerType | endOfTextToAppend )

Appends a string to the end of this one.

Parameters

  startOfTextToAppend | the start of the string to add. This must not be a nullptr
  endOfTextToAppend | the end of the string to add. This must not be a nullptr

Referenced by appendCharPointer().

## appendCharPointer() [2/5]

template<class CharPointer>

void juce::String::appendCharPointer | ( | CharPointer | startOfTextToAppend,
|  | CharPointer | endOfTextToAppend )

inline

Appends a string to the end of this one.

Parameters

  startOfTextToAppend | the start of the string to add. This must not be a nullptr
  endOfTextToAppend | the end of the string to add. This must not be a nullptr

References juce::addBytesToPointer(), juce::CharPointer_UTF8::getBytesRequiredFor(), jassert, and preallocateBytes().

## appendCharPointer() [3/5]

void juce::String::appendCharPointer | ( | CharPointerType | textToAppend | ) |

Appends a string to the end of this one.

## appendCharPointer() [4/5]

template<class CharPointer>

void juce::String::appendCharPointer | ( | CharPointer | textToAppend,
|  | size_t | maxCharsToTake )

inline

Appends a string to the end of this one.

Parameters

  textToAppend | the string to add
  maxCharsToTake | the maximum number of characters to take from the string passed in

References juce::addBytesToPointer(), juce::CharPointer_UTF8::getBytesRequiredFor(), and preallocateBytes().

## appendCharPointer() [5/5]

template<class CharPointer>

void juce::String::appendCharPointer | ( | CharPointer | textToAppend | ) |

inline

Appends a string to the end of this one.

References appendCharPointer().

## isEmpty()

bool juce::String::isEmpty | ( |  | ) | const

inline noexcept

Returns true if the string contains no characters.

Note that there's also an isNotEmpty() method to help write readable code.

See also
  containsNonWhitespaceChars()

Referenced by juce::AndroidDocumentInputSource::createInputStreamFor(), and juce::StandalonePluginHolder::getFilePatterns().

## isNotEmpty()

bool juce::String::isNotEmpty | ( |  | ) | const

inline noexcept

Returns true if the string contains at least one character.

Note that there's also an isEmpty() method to help write readable code.

See also
  containsNonWhitespaceChars()

Referenced by juce::GridItem::Span::Span(), and juce::GridItem::Span::Span().

## clear()

void juce::String::clear | ( |  | ) |

noexcept

Resets this string to be empty.

## equalsIgnoreCase() [1/4]

bool juce::String::equalsIgnoreCase | ( | const String & | other | ) | const

noexcept

Case-insensitive comparison with another string.

References equalsIgnoreCase(), and String().

Referenced by equalsIgnoreCase(), equalsIgnoreCase(), equalsIgnoreCase(), and equalsIgnoreCase().

## equalsIgnoreCase() [2/4]

bool juce::String::equalsIgnoreCase | ( | StringRef | other | ) | const

noexcept

Case-insensitive comparison with another string.

References equalsIgnoreCase().

## equalsIgnoreCase() [3/4]

bool juce::String::equalsIgnoreCase | ( | const wchar_t * | other | ) | const

noexcept

Case-insensitive comparison with another string.

References equalsIgnoreCase().

## equalsIgnoreCase() [4/4]

bool juce::String::equalsIgnoreCase | ( | const char * | other | ) | const

noexcept

Case-insensitive comparison with another string.

References equalsIgnoreCase().

## compare() [1/3]

int juce::String::compare | ( | const String & | other | ) | const

noexcept

Case-sensitive comparison with another string.

Returns
  0 if the two strings are identical; negative if this string comes before the other one alphabetically, or positive if it comes after it.

References compare(), and String().

Referenced by compare(), compare(), and compare().

## compare() [2/3]

int juce::String::compare | ( | const char * | other | ) | const

noexcept

Case-sensitive comparison with another string.

Returns
  0 if the two strings are identical; negative if this string comes before the other one alphabetically, or positive if it comes after it.

References compare().

## compare() [3/3]

int juce::String::compare | ( | const wchar_t * | other | ) | const

noexcept

Case-sensitive comparison with another string.

Returns
  0 if the two strings are identical; negative if this string comes before the other one alphabetically, or positive if it comes after it.

References compare().

## compareIgnoreCase()

int juce::String::compareIgnoreCase | ( | const String & | other | ) | const

noexcept

Case-insensitive comparison with another string.

Returns
  0 if the two strings are identical; negative if this string comes before the other one alphabetically, or positive if it comes after it.

References compareIgnoreCase(), and String().

Referenced by compareIgnoreCase().

## compareNatural()

int juce::String::compareNatural | ( | StringRef | other,
|  | bool | isCaseSensitive = false ) const

noexcept

Compares two strings, taking into account textual characteristics like numbers and spaces.

This comparison is case-insensitive and can detect words and embedded numbers in the strings, making it good for sorting human-readable lists of things like filenames.

Returns
  0 if the two strings are identical; negative if this string comes before the other one alphabetically, or positive if it comes after it.

References compareNatural().

Referenced by juce::File::NaturalFileComparator::compareElements(), and compareNatural().

## startsWith()

bool juce::String::startsWith | ( | StringRef | text | ) | const

noexcept

Tests whether the string begins with another string.

If the parameter is an empty string, this will always return true. Uses a case-sensitive comparison.

References startsWith().

Referenced by startsWith().

## startsWithChar()

bool juce::String::startsWithChar | ( | juce_wchar | character | ) | const

noexcept

Tests whether the string begins with a particular character.

If the character is 0, this will always return false. Uses a case-sensitive comparison.

References startsWithChar().

Referenced by juce::StandalonePluginHolder::getFilePatterns(), and startsWithChar().

## startsWithIgnoreCase()

bool juce::String::startsWithIgnoreCase | ( | StringRef | text | ) | const

noexcept

Tests whether the string begins with another string.

If the parameter is an empty string, this will always return true. Uses a case-insensitive comparison.

References startsWithIgnoreCase().

Referenced by startsWithIgnoreCase().

## endsWith()

bool juce::String::endsWith | ( | StringRef | text | ) | const

noexcept

Tests whether the string ends with another string.

If the parameter is an empty string, this will always return true. Uses a case-sensitive comparison.

References endsWith().

Referenced by endsWith().

## endsWithChar()

bool juce::String::endsWithChar | ( | juce_wchar | character | ) | const

noexcept

Tests whether the string ends with a particular character.

If the character is 0, this will always return false. Uses a case-sensitive comparison.

References endsWithChar().

Referenced by endsWithChar().

## endsWithIgnoreCase()

bool juce::String::endsWithIgnoreCase | ( | StringRef | text | ) | const

noexcept

Tests whether the string ends with another string.

If the parameter is an empty string, this will always return true. Uses a case-insensitive comparison.

References endsWithIgnoreCase().

Referenced by endsWithIgnoreCase().

## contains()

bool juce::String::contains | ( | StringRef | text | ) | const

noexcept

Tests whether the string contains another substring.

If the parameter is an empty string, this will always return true. Uses a case-sensitive comparison.

References contains().

Referenced by contains().

## containsChar()

bool juce::String::containsChar | ( | juce_wchar | character | ) | const

noexcept

Tests whether the string contains a particular character.

Uses a case-sensitive comparison.

References containsChar().

Referenced by containsChar().

## containsIgnoreCase()

bool juce::String::containsIgnoreCase | ( | StringRef | text | ) | const

noexcept

Tests whether the string contains another substring.

Uses a case-insensitive comparison.

References containsIgnoreCase().

Referenced by containsIgnoreCase().

## containsWholeWord()

bool juce::String::containsWholeWord | ( | StringRef | wordToLookFor | ) | const

noexcept

Tests whether the string contains another substring as a distinct word.

Returns
  true if the string contains this word, surrounded by non-alphanumeric characters

See also
  indexOfWholeWord, containsWholeWordIgnoreCase

References containsWholeWord().

Referenced by containsWholeWord().

## containsWholeWordIgnoreCase()

bool juce::String::containsWholeWordIgnoreCase | ( | StringRef | wordToLookFor | ) | const

noexcept

Tests whether the string contains another substring as a distinct word.

Returns
  true if the string contains this word, surrounded by non-alphanumeric characters

See also
  indexOfWholeWordIgnoreCase, containsWholeWord

References containsWholeWordIgnoreCase().

Referenced by containsWholeWordIgnoreCase().

## indexOfWholeWord()

int juce::String::indexOfWholeWord | ( | StringRef | wordToLookFor | ) | const

noexcept

Finds an instance of another substring if it exists as a distinct word.

Returns
  if the string contains this word, surrounded by non-alphanumeric characters, then this will return the index of the start of the substring. If it isn't found, then it will return -1

See also
  indexOfWholeWordIgnoreCase, containsWholeWord

References indexOfWholeWord().

Referenced by indexOfWholeWord().

## indexOfWholeWordIgnoreCase()

int juce::String::indexOfWholeWordIgnoreCase | ( | StringRef | wordToLookFor | ) | const

noexcept

Finds an instance of another substring if it exists as a distinct word.

Returns
  if the string contains this word, surrounded by non-alphanumeric characters, then this will return the index of the start of the substring. If it isn't found, then it will return -1

See also
  indexOfWholeWord, containsWholeWordIgnoreCase

References indexOfWholeWordIgnoreCase().

Referenced by indexOfWholeWordIgnoreCase().

## containsAnyOf()

bool juce::String::containsAnyOf | ( | StringRef | charactersItMightContain | ) | const

noexcept

Looks for any of a set of characters in the string.

Uses a case-sensitive comparison.

Returns
  true if the string contains any of the characters from the string that is passed in.

References containsAnyOf().

Referenced by containsAnyOf().

## containsOnly()

bool juce::String::containsOnly | ( | StringRef | charactersItMightContain | ) | const

noexcept

Looks for a set of characters in the string.

Uses a case-sensitive comparison.

Returns
  Returns false if any of the characters in this string do not occur in the parameter string. If this string is empty, the return value will always be true.

References containsOnly().

Referenced by containsOnly().

## containsNonWhitespaceChars()

bool juce::String::containsNonWhitespaceChars | ( |  | ) | const

noexcept

Returns true if this string contains any non-whitespace characters.

This will return false if the string contains only whitespace characters, or if it's empty.

It is equivalent to calling "myString.trim().isNotEmpty()".

References containsNonWhitespaceChars().

Referenced by containsNonWhitespaceChars().

## matchesWildcard()

bool juce::String::matchesWildcard | ( | StringRef | wildcard,
|  | bool | ignoreCase ) const

noexcept

Returns true if the string matches this simple wildcard expression.

So for example String ("abcdef").matchesWildcard ("*DEF", true) would return true.

This isn't a full-blown regex though! The only wildcard characters supported are "*" and "?". It's mainly intended for filename pattern matching.

References matchesWildcard().

Referenced by matchesWildcard().

## indexOfChar() [1/2]

int juce::String::indexOfChar | ( | juce_wchar | characterToLookFor | ) | const

noexcept

Searches for a character inside this string.

Uses a case-sensitive comparison.

Returns
  the index of the first occurrence of the character in this string, or -1 if it's not found.

References indexOfChar().

Referenced by indexOfChar(), and indexOfChar().

## indexOfChar() [2/2]

int juce::String::indexOfChar | ( | int | startIndex,
|  | juce_wchar | characterToLookFor ) const

noexcept

Searches for a character inside this string.

Uses a case-sensitive comparison.

Parameters

  startIndex | the index from which the search should proceed
  characterToLookFor | the character to look for

Returns
  the index of the first occurrence of the character in this string, or -1 if it's not found.

References indexOfChar().

## indexOfAnyOf()

int juce::String::indexOfAnyOf | ( | StringRef | charactersToLookFor,
|  | int | startIndex = 0,
|  | bool | ignoreCase = false ) const

noexcept

Returns the index of the first character that matches one of the characters passed-in to this method.

This scans the string, beginning from the startIndex supplied, and if it finds a character that appears in the string charactersToLookFor, it returns its index.

If none of these characters are found, it returns -1.

If ignoreCase is true, the comparison will be case-insensitive.

See also
  indexOfChar, lastIndexOfAnyOf

References indexOfAnyOf().

Referenced by indexOfAnyOf().

## indexOf() [1/2]

int juce::String::indexOf | ( | StringRef | textToLookFor | ) | const

noexcept

Searches for a substring within this string.

Uses a case-sensitive comparison.

Returns
  the index of the first occurrence of this substring, or -1 if it's not found. If textToLookFor is an empty string, this will always return 0.

References indexOf().

Referenced by indexOf(), and indexOf().

## indexOf() [2/2]

int juce::String::indexOf | ( | int | startIndex,
|  | StringRef | textToLookFor ) const

noexcept

Searches for a substring within this string.

Uses a case-sensitive comparison.

Parameters

  startIndex | the index from which the search should proceed
  textToLookFor | the string to search for

Returns
  the index of the first occurrence of this substring, or -1 if it's not found. If textToLookFor is an empty string, this will always return -1.

References indexOf().

## indexOfIgnoreCase() [1/2]

int juce::String::indexOfIgnoreCase | ( | StringRef | textToLookFor | ) | const

noexcept

Searches for a substring within this string.

Uses a case-insensitive comparison.

Returns
  the index of the first occurrence of this substring, or -1 if it's not found. If textToLookFor is an empty string, this will always return 0.

References indexOfIgnoreCase().

Referenced by indexOfIgnoreCase(), and indexOfIgnoreCase().

## indexOfIgnoreCase() [2/2]

int juce::String::indexOfIgnoreCase | ( | int | startIndex,
|  | StringRef | textToLookFor ) const

noexcept

Searches for a substring within this string.

Uses a case-insensitive comparison.

Parameters

  startIndex | the index from which the search should proceed
  textToLookFor | the string to search for

Returns
  the index of the first occurrence of this substring, or -1 if it's not found. If textToLookFor is an empty string, this will always return -1.

References indexOfIgnoreCase().

## lastIndexOfChar()

int juce::String::lastIndexOfChar | ( | juce_wchar | character | ) | const

noexcept

Searches for a character inside this string (working backwards from the end of the string).

Uses a case-sensitive comparison.

Returns
  the index of the last occurrence of the character in this string, or -1 if it's not found.

References lastIndexOfChar().

Referenced by lastIndexOfChar().

## lastIndexOf()

int juce::String::lastIndexOf | ( | StringRef | textToLookFor | ) | const

noexcept

Searches for a substring inside this string (working backwards from the end of the string).

Uses a case-sensitive comparison.

Returns
  the index of the start of the last occurrence of the substring within this string, or -1 if it's not found. If textToLookFor is an empty string, this will always return -1.

References lastIndexOf().

Referenced by lastIndexOf().

## lastIndexOfIgnoreCase()

int juce::String::lastIndexOfIgnoreCase | ( | StringRef | textToLookFor | ) | const

noexcept

Searches for a substring inside this string (working backwards from the end of the string).

Uses a case-insensitive comparison.

Returns
  the index of the start of the last occurrence of the substring within this string, or -1 if it's not found. If textToLookFor is an empty string, this will always return -1.

References lastIndexOfIgnoreCase().

Referenced by lastIndexOfIgnoreCase().

## lastIndexOfAnyOf()

int juce::String::lastIndexOfAnyOf | ( | StringRef | charactersToLookFor,
|  | bool | ignoreCase = false ) const

noexcept

Returns the index of the last character in this string that matches one of the characters passed-in to this method.

This scans the string backwards, starting from its end, and if it finds a character that appears in the string charactersToLookFor, it returns its index.

If none of these characters are found, it returns -1.

If ignoreCase is true, the comparison will be case-insensitive.

See also
  lastIndexOf, indexOfAnyOf

References lastIndexOfAnyOf().

Referenced by lastIndexOfAnyOf().

## operator[]()

juce_wchar juce::String::operator[] | ( | int | index | ) | const

noexcept

Returns the character at this index in the string.

In a release build, no checks are made to see if the index is within a valid range, so be careful! In a debug build, the index is checked and an assertion fires if it's out-of-range.

Also beware that depending on the encoding format that the string is using internally, this method may execute in either O(1) or O(n) time, so be careful when using it in your algorithms. If you're scanning through a string to inspect its characters, you should never use this operator for random access, it's far more efficient to call getCharPointer() to return a pointer, and then to use that to iterate the string.

See also
  getCharPointer

## getLastCharacter()

juce_wchar juce::String::getLastCharacter | ( |  | ) | const

noexcept

Returns the final character of the string.

If the string is empty this will return 0.

References getLastCharacter().

Referenced by getLastCharacter().

## substring() [1/2]

String juce::String::substring | ( | int | startIndex,
|  | int | endIndex ) const

Returns a subsection of the string.

If the range specified is beyond the limits of the string, as much as possible is returned.

Parameters

  startIndex | the index of the start of the substring needed
  endIndex | all characters from startIndex up to (but not including) this index are returned

See also
  fromFirstOccurrenceOf, dropLastCharacters, getLastCharacters, upToFirstOccurrenceOf

References String(), and substring().

Referenced by substring(), and substring().

## substring() [2/2]

String juce::String::substring | ( | int | startIndex | ) | const

Returns a section of the string, starting from a given position.

Parameters

  startIndex | the first character to include. If this is beyond the end of the string, an empty string is returned. If it is zero or less, the whole string is returned.

Returns
  the substring from startIndex up to the end of the string

See also
  dropLastCharacters, getLastCharacters, fromFirstOccurrenceOf, upToFirstOccurrenceOf, fromLastOccurrenceOf

References String(), and substring().

## dropLastCharacters()

String juce::String::dropLastCharacters | ( | int | numberToDrop | ) | const

Returns a version of this string with a number of characters removed from the end.

Parameters

  numberToDrop | the number of characters to drop from the end of the string. If this is greater than the length of the string, an empty string will be returned. If zero or less, the original string will be returned.

See also
  substring, fromFirstOccurrenceOf, upToFirstOccurrenceOf, fromLastOccurrenceOf, getLastCharacter

References dropLastCharacters(), and String().

Referenced by dropLastCharacters().

## getLastCharacters()

String juce::String::getLastCharacters | ( | int | numCharacters | ) | const

Returns a number of characters from the end of the string.

This returns the last numCharacters characters from the end of the string. If the string is shorter than numCharacters, the whole string is returned.

See also
  substring, dropLastCharacters, getLastCharacter

References getLastCharacters(), and String().

Referenced by getLastCharacters().

## fromFirstOccurrenceOf()

String juce::String::fromFirstOccurrenceOf | ( | StringRef | substringToStartFrom,
|  | bool | includeSubStringInResult,
|  | bool | ignoreCase ) const

Returns a section of the string starting from a given substring.

This will search for the first occurrence of the given substring, and return the section of the string starting from the point where this is found (optionally not including the substring itself).

e.g. for the string "123456", fromFirstOccurrenceOf ("34", true) would return "3456", and fromFirstOccurrenceOf ("34", false) would return "56".

If the substring isn't found, the method will return an empty string.

If ignoreCase is true, the comparison will be case-insensitive.

See also
  upToFirstOccurrenceOf, fromLastOccurrenceOf

References fromFirstOccurrenceOf(), and String().

Referenced by fromFirstOccurrenceOf().

## fromLastOccurrenceOf()

String juce::String::fromLastOccurrenceOf | ( | StringRef | substringToFind,
|  | bool | includeSubStringInResult,
|  | bool | ignoreCase ) const

Returns a section of the string starting from the last occurrence of a given substring.

Similar to fromFirstOccurrenceOf(), but using the last occurrence of the substring, and unlike fromFirstOccurrenceOf(), if the substring isn't found, this method will return the whole of the original string.

See also
  fromFirstOccurrenceOf, upToLastOccurrenceOf

References fromLastOccurrenceOf(), and String().

Referenced by fromLastOccurrenceOf().

## upToFirstOccurrenceOf()

String juce::String::upToFirstOccurrenceOf | ( | StringRef | substringToEndWith,
|  | bool | includeSubStringInResult,
|  | bool | ignoreCase ) const

Returns the start of this string, up to the first occurrence of a substring.

This will search for the first occurrence of a given substring, and then return a copy of the string, up to the position of this substring, optionally including or excluding the substring itself in the result.

e.g. for the string "123456", upTo ("34", false) would return "12", and upTo ("34", true) would return "1234".

If the substring isn't found, this will return the whole of the original string.

See also
  upToLastOccurrenceOf, fromFirstOccurrenceOf

References String(), and upToFirstOccurrenceOf().

Referenced by upToFirstOccurrenceOf().

## upToLastOccurrenceOf()

String juce::String::upToLastOccurrenceOf | ( | StringRef | substringToFind,
|  | bool | includeSubStringInResult,
|  | bool | ignoreCase ) const

Returns the start of this string, up to the last occurrence of a substring.

Similar to upToFirstOccurrenceOf(), but this finds the last occurrence rather than the first. If the substring isn't found, this will return the whole of the original string.

See also
  upToFirstOccurrenceOf, fromFirstOccurrenceOf

References String(), and upToLastOccurrenceOf().

Referenced by upToLastOccurrenceOf().

## trim()

String juce::String::trim | ( |  | ) | const

Returns a copy of this string with any whitespace characters removed from the start and end.

References String(), and trim().

Referenced by trim().

## trimStart()

String juce::String::trimStart | ( |  | ) | const

Returns a copy of this string with any whitespace characters removed from the start.

References String(), and trimStart().

Referenced by trimStart().

## trimEnd()

String juce::String::trimEnd | ( |  | ) | const

Returns a copy of this string with any whitespace characters removed from the end.

References String(), and trimEnd().

Referenced by trimEnd().

## trimCharactersAtStart()

String juce::String::trimCharactersAtStart | ( | StringRef | charactersToTrim | ) | const

Returns a copy of this string, having removed a specified set of characters from its start.

Characters are removed from the start of the string until it finds one that is not in the specified set, and then it stops.

Parameters

  charactersToTrim | the set of characters to remove.

See also
  trim, trimStart, trimCharactersAtEnd

References String(), and trimCharactersAtStart().

Referenced by trimCharactersAtStart().

## trimCharactersAtEnd()

String juce::String::trimCharactersAtEnd | ( | StringRef | charactersToTrim | ) | const

Returns a copy of this string, having removed a specified set of characters from its end.

Characters are removed from the end of the string until it finds one that is not in the specified set, and then it stops.

Parameters

  charactersToTrim | the set of characters to remove.

See also
  trim, trimEnd, trimCharactersAtStart

References String(), and trimCharactersAtEnd().

Referenced by trimCharactersAtEnd().

## toUpperCase()

String juce::String::toUpperCase | ( |  | ) | const

Returns an upper-case version of this string.

References String(), and toUpperCase().

Referenced by toUpperCase().

## toLowerCase()

String juce::String::toLowerCase | ( |  | ) | const

Returns an lower-case version of this string.

References String(), and toLowerCase().

Referenced by toLowerCase().

## replaceSection()

String juce::String::replaceSection | ( | int | startIndex,
|  | int | numCharactersToReplace,
|  | StringRef | stringToInsert ) const

Replaces a sub-section of the string with another string.

This will return a copy of this string, with a set of characters from startIndex to startIndex + numCharsToReplace removed, and with a new string inserted in their place.

Note that this is a const method, and won't alter the string itself.

Parameters

  startIndex | the first character to remove. If this is beyond the bounds of the string, it will be constrained to a valid range.
  numCharactersToReplace | the number of characters to remove. If zero or less, no characters will be taken out.
  stringToInsert | the new string to insert at startIndex after the characters have been removed.

References replaceSection(), and String().

Referenced by replaceSection().

## replace()

String juce::String::replace | ( | StringRef | stringToReplace,
|  | StringRef | stringToInsertInstead,
|  | bool | ignoreCase = false ) const

Replaces all occurrences of a substring with another string.

Returns a copy of this string, with any occurrences of stringToReplace swapped for stringToInsertInstead.

Note that this is a const method, and won't alter the string itself.

References replace(), and String().

Referenced by replace().

## replaceFirstOccurrenceOf()

String juce::String::replaceFirstOccurrenceOf | ( | StringRef | stringToReplace,
|  | StringRef | stringToInsertInstead,
|  | bool | ignoreCase = false ) const

Replaces the first occurrence of a substring with another string.

Returns a copy of this string, with the first occurrence of stringToReplace swapped for stringToInsertInstead.

Note that this is a const method, and won't alter the string itself.

References replaceFirstOccurrenceOf(), and String().

Referenced by replaceFirstOccurrenceOf().

## replaceCharacter()

String juce::String::replaceCharacter | ( | juce_wchar | characterToReplace,
|  | juce_wchar | characterToInsertInstead ) const

Returns a string with all occurrences of a character replaced with a different one.

References replaceCharacter(), and String().

Referenced by replaceCharacter().

## replaceCharacters()

String juce::String::replaceCharacters | ( | StringRef | charactersToReplace,
|  | StringRef | charactersToInsertInstead ) const

Replaces a set of characters with another set.

Returns a string in which each character from charactersToReplace has been replaced by the character at the equivalent position in newCharacters (so the two strings passed in must be the same length).

e.g. replaceCharacters ("abc", "def") replaces 'a' with 'd', 'b' with 'e', etc.

Note that this is a const method, and won't affect the string itself.

References replaceCharacters(), and String().

Referenced by replaceCharacters().

## retainCharacters()

String juce::String::retainCharacters | ( | StringRef | charactersToRetain | ) | const

Returns a version of this string that only retains a fixed set of characters.

This will return a copy of this string, omitting any characters which are not found in the string passed-in.

e.g. for "1122334455", retainCharacters ("432") would return "223344"

Note that this is a const method, and won't alter the string itself.

References retainCharacters(), and String().

Referenced by retainCharacters().

## removeCharacters()

String juce::String::removeCharacters | ( | StringRef | charactersToRemove | ) | const

Returns a version of this string with a set of characters removed.

This will return a copy of this string, omitting any characters which are found in the string passed-in.

e.g. for "1122334455", removeCharacters ("432") would return "1155"

Note that this is a const method, and won't alter the string itself.

References removeCharacters(), and String().

Referenced by removeCharacters().

## initialSectionContainingOnly()

String juce::String::initialSectionContainingOnly | ( | StringRef | permittedCharacters | ) | const

Returns a section from the start of the string that only contains a certain set of characters.

This returns the leftmost section of the string, up to (and not including) the first character that doesn't appear in the string passed in.

References initialSectionContainingOnly(), and String().

Referenced by initialSectionContainingOnly().

## initialSectionNotContaining()

String juce::String::initialSectionNotContaining | ( | StringRef | charactersToStopAt | ) | const

Returns a section from the start of the string that only contains a certain set of characters.

This returns the leftmost section of the string, up to (and not including) the first character that occurs in the string passed in. (If none of the specified characters are found in the string, the return value will just be the original string).

References initialSectionNotContaining(), and String().

Referenced by initialSectionNotContaining().

## isQuotedString()

bool juce::String::isQuotedString | ( |  | ) | const

Checks whether the string might be in quotation marks.

Returns
  true if the string begins with a quote character (either a double or single quote). It is also true if there is whitespace before the quote, but it doesn't check the end of the string.

See also
  unquoted, quoted

References isQuotedString().

Referenced by isQuotedString().

## unquoted()

String juce::String::unquoted | ( |  | ) | const

Removes quotation marks from around the string, (if there are any).

Returns a copy of this string with any quotes removed from its ends. Quotes that aren't at the ends of the string are not affected. If there aren't any quotes, the original string is returned.

Note that this is a const method, and won't alter the string itself.

See also
  isQuotedString, quoted

References String(), and unquoted().

Referenced by unquoted().

## quoted()

String juce::String::quoted | ( | juce_wchar | quoteCharacter = '"' | ) | const

Adds quotation marks around a string.

This will return a copy of the string with a quote at the start and end, (but won't add the quote if there's already one there, so it's safe to call this on strings that may already have quotes around them).

Note that this is a const method, and won't alter the string itself.

Parameters

  quoteCharacter | the character to add at the start and end

See also
  isQuotedString, unquoted

References quoted(), and String().

Referenced by quoted().

## repeatedString()

String juce::String::repeatedString | ( | StringRef | stringToRepeat,
|  | int | numberOfTimesToRepeat )

static

Creates a string which is a version of a string repeated and joined together.

Parameters

  stringToRepeat | the string to repeat
  numberOfTimesToRepeat | how many times to repeat it

References repeatedString(), and String().

Referenced by repeatedString().

## paddedLeft()

String juce::String::paddedLeft | ( | juce_wchar | padCharacter,
|  | int | minimumLength ) const

Returns a copy of this string with the specified character repeatedly added to its beginning until the total length is at least the minimum length specified.

References paddedLeft(), and String().

Referenced by paddedLeft().

## paddedRight()

String juce::String::paddedRight | ( | juce_wchar | padCharacter,
|  | int | minimumLength ) const

Returns a copy of this string with the specified character repeatedly added to its end until the total length is at least the minimum length specified.

References paddedRight(), and String().

Referenced by paddedRight().

## createStringFromData()

String juce::String::createStringFromData | ( | const void * | data,
|  | int | size )

static

Creates a string from data in an unknown format.

This looks at some binary data and tries to guess whether it's Unicode or 8-bit characters, then returns a string that represents it correctly.

Should be able to handle Unicode endianness correctly, by looking at the first two bytes.

References createStringFromData(), and String().

Referenced by createStringFromData().

## formatted()

template<typename... Args>

String juce::String::formatted | ( | const String & | formatStr,
|  | Args... | args )

inline static

Creates a String from a printf-style parameter list.

I don't like this method. I don't use it myself, and I recommend avoiding it and using the operator<< methods or pretty much anything else instead. It's only provided here because of the popular unrest that was stirred-up when I tried to remove it...

If you're really determined to use it, at least make sure that you never, ever, pass any String objects to it as parameters. And bear in mind that internally, depending on the platform, it may be using wchar_t or char character types, so that even string literals can't be safely used as parameters if you're writing portable code.

References formatted(), and String().

Referenced by formatted().

## begin()

CharPointerType juce::String::begin | ( |  | ) | const

inline

Returns an iterator pointing at the beginning of the string.

References getCharPointer().

Referenced by end().

## end()

CharPointerType juce::String::end | ( |  | ) | const

inline

Returns an iterator pointing at the terminating null of the string.

Note that this has to find the terminating null before returning it, so prefer to call this once before looping and then reuse the result, rather than calling 'end()' each time through the loop.

String str = ...;
// BEST
for (auto c : str)
DBG (c);
// GOOD
for (auto ptr = str.begin(), end = str.end(); ptr != end; ++ptr)
DBG (*ptr);
std::for_each (str.begin(), str.end(), [] (juce_wchar c) { DBG (c); });
// BAD
for (auto ptr = str.begin(); ptr != str.end(); ++ptr)
DBG (*ptr);
juce::String::String
String() noexcept
Creates an empty string.
juce::String::end
CharPointerType end() const
Returns an iterator pointing at the terminating null of the string.
Definition juce_String.h:976
DBG
#define DBG(textToWrite)
Writes a string to the standard error stream.
Definition juce_PlatformDefs.h:159
juce::juce_wchar
wchar_t juce_wchar
A platform-independent 32-bit unicode character type.
Definition juce_CharacterFunctions.h:56

References begin().

Referenced by String(), String(), and String().

## getIntValue()

int juce::String::getIntValue | ( |  | ) | const

noexcept

Reads the value of the string as a decimal number (up to 32 bits in size).

Returns
  the value of the string as a 32 bit signed base-10 integer.

See also
  getTrailingIntValue, getHexValue32, getHexValue64

## getLargeIntValue()

int64 juce::String::getLargeIntValue | ( |  | ) | const

noexcept

Reads the value of the string as a decimal number (up to 64 bits in size).

Returns
  the value of the string as a 64 bit signed base-10 integer.

References getLargeIntValue().

Referenced by getLargeIntValue().

## getTrailingIntValue()

int juce::String::getTrailingIntValue | ( |  | ) | const

noexcept

Parses a decimal number from the end of the string.

This will look for a value at the end of the string. e.g. for "321 xyz654" it will return 654; for "2 3 4" it'll return 4.

If the string ends with a hyphen followed by numeric characters, the return value will be negative.

See also
  getIntValue

References getTrailingIntValue().

Referenced by getTrailingIntValue().

## getFloatValue()

float juce::String::getFloatValue | ( |  | ) | const

noexcept

Parses this string as a floating point number.

Returns
  the value of the string as a 32-bit floating point value.

See also
  getDoubleValue

References getFloatValue().

Referenced by getFloatValue().

## getDoubleValue()

double juce::String::getDoubleValue | ( |  | ) | const

noexcept

Parses this string as a floating point number.

Returns
  the value of the string as a 64-bit floating point value.

See also
  getFloatValue

References getDoubleValue().

Referenced by getDoubleValue().

## getHexValue32()

int juce::String::getHexValue32 | ( |  | ) | const

noexcept

Parses the string as a hexadecimal number.

Non-hexadecimal characters in the string are ignored.

If the string contains too many characters, then the lowest significant digits are returned, e.g. "ffff12345678" would produce 0x12345678.

Returns
  a 32-bit number which is the value of the string in hex.

References getHexValue32().

Referenced by getHexValue32().

## getHexValue64()

int64 juce::String::getHexValue64 | ( |  | ) | const

noexcept

Parses the string as a hexadecimal number.

Non-hexadecimal characters in the string are ignored.

If the string contains too many characters, then the lowest significant digits are returned, e.g. "ffff1234567812345678" would produce 0x1234567812345678.

Returns
  a 64-bit number which is the value of the string in hex.

References getHexValue64().

Referenced by getHexValue64().

## toHexString() [1/2]

template<typename IntegerType>

String juce::String::toHexString | ( | IntegerType | number | ) |

inline static

Returns a string representing this numeric value in hexadecimal.

References String(), and toHexString().

Referenced by toHexString(), and juce::CppTokeniserFunctions::writeEscapeChars().

## toHexString() [2/2]

String juce::String::toHexString | ( | const void * | data,
|  | int | size,
|  | int | groupSize = 1 )

static

Returns a string containing a hex dump of a block of binary data.

Parameters

  data | the binary data to use as input
  size | how many bytes of data to use
  groupSize | how many bytes are grouped together before inserting a space into the output. e.g. group size 0 has no spaces, group size 1 looks like: "be a1 c2 ff", group size 2 looks like "bea1 c2ff".

References String().

## toDecimalStringWithSignificantFigures()

template<typename DecimalType>

String juce::String::toDecimalStringWithSignificantFigures | ( | DecimalType | number,
|  | int | numberOfSignificantFigures )

inline static

Returns a string containing a decimal with a set number of significant figures.

Parameters

  number | the input number
  numberOfSignificantFigures | the number of significant figures to use

References juce::exactlyEqual(), jassert, shift, and String().

## getCharPointer()

CharPointerType juce::String::getCharPointer | ( |  | ) | const

inline noexcept

Returns the character pointer currently being used to store this string.

Because it returns a reference to the string's internal data, the pointer that is returned must not be stored anywhere, as it can be deleted whenever the string changes.

Referenced by begin().

## toUTF8()

CharPointer_UTF8 juce::String::toUTF8 | ( |  | ) | const

Returns a pointer to a UTF-8 version of this string.

Because it returns a reference to the string's internal data, the pointer that is returned must not be stored anywhere, as it can be deleted whenever the string changes.

To find out how many bytes you need to store this string as UTF-8, you can call CharPointer_UTF8::getBytesRequiredFor (myString.getCharPointer())

See also
  toRawUTF8, getCharPointer, toUTF16, toUTF32

## toRawUTF8()

const char * juce::String::toRawUTF8 | ( |  | ) | const

Returns a pointer to a UTF-8 version of this string.

Because it returns a reference to the string's internal data, the pointer that is returned must not be stored anywhere, as it can be deleted whenever the string changes.

To find out how many bytes you need to store this string as UTF-8, you can call CharPointer_UTF8::getBytesRequiredFor (myString.getCharPointer())

See also
  getCharPointer, toUTF8, toUTF16, toUTF32

Referenced by juce::CppTokeniserFunctions::addEscapeChars(), and juce::operator<<().

## toUTF16()

CharPointer_UTF16 juce::String::toUTF16 | ( |  | ) | const

Returns a pointer to a UTF-16 version of this string.

Because it returns a reference to the string's internal data, the pointer that is returned must not be stored anywhere, as it can be deleted whenever the string changes.

To find out how many bytes you need to store this string as UTF-16, you can call CharPointer_UTF16::getBytesRequiredFor (myString.getCharPointer())

See also
  getCharPointer, toUTF8, toUTF32

## toUTF32()

CharPointer_UTF32 juce::String::toUTF32 | ( |  | ) | const

Returns a pointer to a UTF-32 version of this string.

Because it returns a reference to the string's internal data, the pointer that is returned must not be stored anywhere, as it can be deleted whenever the string changes.

See also
  getCharPointer, toUTF8, toUTF16

## toWideCharPointer()

const wchar_t * juce::String::toWideCharPointer | ( |  | ) | const

Returns a pointer to a wchar_t version of this string.

Because it returns a reference to the string's internal data, the pointer that is returned must not be stored anywhere, as it can be deleted whenever the string changes.

Bear in mind that the wchar_t type is different on different platforms, so on Windows, this will be equivalent to calling toUTF16(), on unix it'll be the same as calling toUTF32(), etc.

See also
  getCharPointer, toUTF8, toUTF16, toUTF32

Referenced by juce::operator<<().

## toStdString()

std::string juce::String::toStdString | ( |  | ) | const

## fromUTF8() [1/2]

String juce::String::fromUTF8 | ( | const char * | utf8buffer,
|  | int | bufferSizeBytes = -1 )

static

Creates a String from a UTF-8 encoded buffer.

If the size is < 0, it'll keep reading until it hits a zero.

References String().

## fromUTF8() [2/2]

String juce::String::fromUTF8 | ( | const char8_t * | utf8buffer,
|  | int | bufferSizeBytes = -1 )

static

Creates a String from a UTF-8 encoded buffer.

If the size is < 0, it'll keep reading until it hits a zero.

References String().

## getNumBytesAsUTF8()

size_t juce::String::getNumBytesAsUTF8 | ( |  | ) | const

noexcept

Returns the number of bytes required to represent this string as UTF8.

The number returned does NOT include the trailing zero.

See also
  toUTF8, copyToUTF8

## copyToUTF8()

size_t juce::String::copyToUTF8 | ( | CharPointer_UTF8::CharType * | destBuffer,
|  | size_t | maxBufferSizeBytes ) const

noexcept

Copies the string to a buffer as UTF-8 characters.

Returns the number of bytes copied to the buffer, including the terminating null character.

To find out how many bytes you need to store this string as UTF-8, you can call CharPointer_UTF8::getBytesRequiredFor (myString.getCharPointer())

Parameters

  destBuffer | the place to copy it to; if this is a null pointer, the method just returns the number of bytes required (including the terminating null character).
  maxBufferSizeBytes | the size of the destination buffer, in bytes. If the string won't fit, it'll put in as many as it can while still allowing for a terminating null char at the end, and will return the number of bytes that were actually used.

See also
  CharPointer_UTF8::writeWithDestByteLimit

References copyToUTF8().

Referenced by copyToUTF8().

## copyToUTF16()

size_t juce::String::copyToUTF16 | ( | CharPointer_UTF16::CharType * | destBuffer,
|  | size_t | maxBufferSizeBytes ) const

noexcept

Copies the string to a buffer as UTF-16 characters.

Returns the number of bytes copied to the buffer, including the terminating null character.

To find out how many bytes you need to store this string as UTF-16, you can call CharPointer_UTF16::getBytesRequiredFor (myString.getCharPointer())

Parameters

  destBuffer | the place to copy it to; if this is a null pointer, the method just returns the number of bytes required (including the terminating null character).
  maxBufferSizeBytes | the size of the destination buffer, in bytes. If the string won't fit, it'll put in as many as it can while still allowing for a terminating null char at the end, and will return the number of bytes that were actually used.

See also
  CharPointer_UTF16::writeWithDestByteLimit

References copyToUTF16().

Referenced by copyToUTF16().

## copyToUTF32()

size_t juce::String::copyToUTF32 | ( | CharPointer_UTF32::CharType * | destBuffer,
|  | size_t | maxBufferSizeBytes ) const

noexcept

Copies the string to a buffer as UTF-32 characters.

Returns the number of bytes copied to the buffer, including the terminating null character.

To find out how many bytes you need to store this string as UTF-32, you can call CharPointer_UTF32::getBytesRequiredFor (myString.getCharPointer())

Parameters

  destBuffer | the place to copy it to; if this is a null pointer, the method just returns the number of bytes required (including the terminating null character).
  maxBufferSizeBytes | the size of the destination buffer, in bytes. If the string won't fit, it'll put in as many as it can while still allowing for a terminating null char at the end, and will return the number of bytes that were actually used.

See also
  CharPointer_UTF32::writeWithDestByteLimit

References copyToUTF32().

Referenced by copyToUTF32().

## preallocateBytes()

void juce::String::preallocateBytes | ( | size_t | numBytesNeeded | ) |

Increases the string's internally allocated storage.

Although the string's contents won't be affected by this call, it will increase the amount of memory allocated internally for the string to grow into.

If you're about to make a large number of calls to methods such as += or <<, it's more efficient to preallocate enough extra space beforehand, so that these methods won't have to keep resizing the string to append the extra characters.

Parameters

  numBytesNeeded | the number of bytes to allocate storage for. If this value is less than the currently allocated size, it will have no effect.

References preallocateBytes().

Referenced by appendCharPointer(), appendCharPointer(), preallocateBytes(), and juce::Rectangle< ValueType >::toString().

## swapWith()

void juce::String::swapWith | ( | String & | other | ) |

noexcept

Swaps the contents of this string with another one.

This is a very fast operation, as no allocation or copying needs to be done.

References String(), and swapWith().

Referenced by swapWith().

## fromCFString()

String juce::String::fromCFString | ( | CFStringRef | cfString | ) |

static

OSX ONLY - Creates a String from an OSX CFString.

References String().

## toCFString()

CFStringRef juce::String::toCFString | ( |  | ) | const

OSX ONLY - Converts this string to a CFString.

Remember that you must use CFRelease() to free the returned string when you're finished with it.

## convertToPrecomposedUnicode()

String juce::String::convertToPrecomposedUnicode | ( |  | ) | const

OSX ONLY - Returns a copy of this string in which any decomposed unicode characters have been converted to their precomposed equivalents.

References String().

## getReferenceCount()

int juce::String::getReferenceCount | ( |  | ) | const

noexcept

Returns the number of String objects which are currently sharing the same internal data as this one.

References String().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited